VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3825
   ClientLeft      =   5835
   ClientTop       =   3195
   ClientWidth     =   5040
   LinkTopic       =   "Form1"
   ScaleHeight     =   3825
   ScaleWidth      =   5040
   Begin VB.CommandButton cmdCancelNew 
      Caption         =   "&Cancel New Record"
      Enabled         =   0   'False
      Height          =   375
      Left            =   780
      TabIndex        =   14
      Top             =   3060
      Width           =   2115
   End
   Begin VB.CommandButton cmdUndo 
      Caption         =   "&Undo"
      Height          =   375
      Left            =   3360
      TabIndex        =   12
      Top             =   2100
      Width           =   1335
   End
   Begin VB.CommandButton cmdDeleteRecord 
      Caption         =   "&Delete Record"
      Height          =   375
      Left            =   3360
      TabIndex        =   13
      Top             =   3120
      Width           =   1335
   End
   Begin VB.CommandButton cmdSaveRecord 
      Caption         =   "&Save Record"
      Enabled         =   0   'False
      Height          =   375
      Left            =   780
      TabIndex        =   11
      Top             =   2580
      Width           =   2115
   End
   Begin VB.CommandButton cmdNewRecord 
      Caption         =   "Ne&w Record"
      Height          =   375
      Left            =   3360
      TabIndex        =   10
      Top             =   2640
      Width           =   1335
   End
   Begin VB.CommandButton cmdMoveFirst 
      Caption         =   "&First Record"
      Height          =   375
      Left            =   3360
      TabIndex        =   6
      Top             =   180
      Width           =   1335
   End
   Begin VB.CommandButton cmdMovePrevious 
      Caption         =   "&Previous Record"
      Height          =   375
      Left            =   3360
      TabIndex        =   7
      Top             =   660
      Width           =   1335
   End
   Begin VB.CommandButton cmdMoveLast 
      Caption         =   "&Last Record"
      Height          =   375
      Left            =   3360
      TabIndex        =   9
      Top             =   1620
      Width           =   1335
   End
   Begin VB.CommandButton cmdMoveNext 
      Caption         =   "&Next Record"
      Height          =   375
      Left            =   3360
      TabIndex        =   8
      Top             =   1140
      Width           =   1335
   End
   Begin VB.TextBox txtYearBorn 
      DataField       =   "Year Born"
      DataSource      =   "datAuthors"
      Height          =   375
      Left            =   1200
      TabIndex        =   5
      Top             =   1920
      Width           =   1815
   End
   Begin VB.TextBox txtAuthor 
      DataField       =   "Author"
      DataSource      =   "datAuthors"
      Height          =   405
      Left            =   1200
      TabIndex        =   3
      Top             =   1200
      Width           =   1815
   End
   Begin VB.TextBox txtAuthID 
      DataField       =   "Au_ID"
      DataSource      =   "datAuthors"
      Enabled         =   0   'False
      Height          =   375
      Left            =   1200
      TabIndex        =   1
      Top             =   480
      Width           =   1815
   End
   Begin VB.Data datAuthors 
      Caption         =   "Use Arrows To View Data"
      Connect         =   "Access"
      DatabaseName    =   "..\Biblio.mdb"
      DefaultCursorType=   0  'DefaultCursor
      DefaultType     =   2  'UseODBC
      Exclusive       =   0   'False
      Height          =   375
      Left            =   0
      Options         =   0
      ReadOnly        =   0   'False
      RecordsetType   =   1  'Dynaset
      RecordSource    =   "Authors"
      Top             =   0
      Visible         =   0   'False
      Width           =   2000
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Year Born:"
      Height          =   195
      Left            =   360
      TabIndex        =   4
      Top             =   2040
      Width           =   750
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Author Name:"
      Height          =   195
      Left            =   120
      TabIndex        =   2
      Top             =   1320
      Width           =   975
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Author ID:"
      Height          =   195
      Left            =   360
      TabIndex        =   0
      Top             =   600
      Width           =   720
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private blnAddingNewRecord  As Boolean
Private blnValidationError  As Boolean

Private Sub cmdCancelNew_Click()
    
    'cancel the AddNew
    datAuthors.Recordset.CancelUpdate
    datAuthors.UpdateControls
    
    'enable & disable the appropriate buttons
    cmdSaveRecord.Enabled = False
    cmdCancelNew.Enabled = False
    
    cmdMoveFirst.Enabled = True
    cmdMoveLast.Enabled = True
    cmdMovePrevious.Enabled = True
    cmdMoveNext.Enabled = True
    cmdDeleteRecord.Enabled = True
    cmdNewRecord.Enabled = True
    cmdUndo.Enabled = True
    blnAddingNewRecord = False
    
End Sub

Private Sub cmdDeleteRecord_Click()

    On Error GoTo Delete_Error

    If MsgBox("Are you sure you want to delete this record?", _
                vbQuestion + vbYesNo + vbDefaultButton2, _
            "Confirm") = vbNo Then
            Exit Sub
        End If

    'delete the current record
    datAuthors.Recordset.Delete
    
    'move to a valid record
    cmdMoveNext_Click
    
    Exit Sub
    
Delete_Error:
    MsgBox "This record cannot be deleted. Error code = " _
           & CStr(Err.Number) & vbCrLf & Err.Description, _
           vbCritical, "Cannot Delete"

End Sub

Private Sub cmdMoveFirst_Click()

    datAuthors.Recordset.MoveFirst
    
End Sub

Private Sub cmdMoveLast_Click()

    datAuthors.Recordset.MoveLast
    
End Sub

Private Sub cmdMoveNext_Click()

    datAuthors.Recordset.MoveNext
    If datAuthors.Recordset.EOF = True Then
        datAuthors.Recordset.MoveLast
    End If
  
End Sub

Private Sub cmdMovePrevious_Click()

    datAuthors.Recordset.MovePrevious
    If datAuthors.Recordset.BOF = True Then
        datAuthors.Recordset.MoveFirst
    End If
    
End Sub

Private Sub cmdNewRecord_Click()
    
    'let the user add data for a new record
    datAuthors.Recordset.AddNew
    
    If blnValidationError Then Exit Sub

    'disable the buttons that shouldn't be used,
    'and enable the buttons that should
    cmdSaveRecord.Enabled = True
    cmdCancelNew.Enabled = True
    
    cmdMoveFirst.Enabled = False
    cmdMoveLast.Enabled = False
    cmdMovePrevious.Enabled = False
    cmdMoveNext.Enabled = False
    cmdDeleteRecord.Enabled = False
    cmdNewRecord.Enabled = False
    cmdUndo.Enabled = False
    
    blnAddingNewRecord = True
    
End Sub

Private Sub cmdSaveRecord_Click()

    'user wants to save the newly added record.

    'update the database with the new data
    datAuthors.Recordset.Update
    
    If blnValidationError Then Exit Sub
    
    ' make the new record the current record
    datAuthors.Recordset.Bookmark _
        = datAuthors.Recordset.LastModified

    'enable & disable the appropriate buttons
    cmdSaveRecord.Enabled = False
    cmdCancelNew.Enabled = False
    
    cmdMoveFirst.Enabled = True
    cmdMoveLast.Enabled = True
    cmdMovePrevious.Enabled = True
    cmdMoveNext.Enabled = True
    cmdDeleteRecord.Enabled = True
    cmdNewRecord.Enabled = True
    cmdUndo.Enabled = True
    
    blnAddingNewRecord = False
    
End Sub

Private Sub cmdUndo_Click()
    datAuthors.UpdateControls
End Sub

Private Sub datAuthors_Validate(Action As Integer, Save As Integer)
    
    If Action = vbDataActionBookmark Then Exit Sub
    
    If Action = vbDataActionDelete Then Exit Sub
    
    'check to see if a valid author id is entered:
    If txtAuthor.DataChanged Or blnAddingNewRecord Then
        If Trim$(txtAuthor) = "" Then
            MsgBox "Author name must be entered"
            txtAuthor.SetFocus
            GoTo CancelValidateAction
        End If
    End If
    
    'check to see if a valid year is entered
    If txtYearBorn.DataChanged Or blnAddingNewRecord Then
        If Val(txtYearBorn) = 0 Then
            MsgBox "Invalid year"
            txtYearBorn.SetFocus
            GoTo CancelValidateAction
        End If
    End If
    
    blnValidationError = False
    
    Exit Sub
    
CancelValidateAction:
    blnValidationError = True
    Action = vbDataActionCancel
    Save = False

End Sub

